﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace DarwinDecriptor.Test
{
    [TestClass]
    public class StringExtensionsTest
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentException))]
        public void ReverseStringIncorectStringLengthThrowException()
        {
            var target = "ABCDEFGHx";
            target.ReverseString(2);
        }

        [TestMethod]
        public void ReverseStringTwoCharLengthReturnReversedString()
        {
            var expected = "GHEFCDAB";
            var target = "ABCDEFGH";
            
            var actual = target.ReverseString(2);

            Assert.AreEqual(expected, actual);
        }

        [TestMethod]
        public void ReverseStringFourCharLengthReturnReversedString()
        {
            var expected = "EFGHABCD";
            var target = "ABCDEFGH";

            var actual = target.ReverseString(4);

            Assert.AreEqual(expected, actual);
        }

        [TestMethod]
        public void ReverseStringTreeCharLengthReturnReversedString()
        {
            var expected = "GHIDEFABC";
            var target = "ABCDEFGHI";

            var actual = target.ReverseString(3);

            Assert.AreEqual(expected, actual);
        }
    }
}
